<?php

namespace common\modules\product\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\modules\product\models\RemoteProducts;

/**
 * RemoteProductsSearch represents the model behind the search form about `common\modules\product\models\RemoteProducts`.
 */
class RemoteProductsSearch extends RemoteProducts
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Name', 'ID_chief', 'Article', 'Brand', 'ID', 'Date_create'], 'safe'],
            [['Price', 'Price_old'], 'number'],
            [['local_id'], 'integer'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = RemoteProducts::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'Price' => $this->Price,
            'Price_old' => $this->Price_old,
            'Date_create' => $this->Date_create,
            'local_id' => $this->local_id,
        ]);

        $query->andFilterWhere(['like', 'Name', $this->Name])
            ->andFilterWhere(['like', 'ID_chief', $this->ID_chief])
            ->andFilterWhere(['like', 'Article', $this->Article])
            ->andFilterWhere(['like', 'Brand', $this->Brand])
            ->andFilterWhere(['like', 'ID', $this->ID]);

        return $dataProvider;
    }
}
